#ifndef _DECDECODER_H
#define _DECDECODER_H
#include "libdecode.h"
#include "common.h"

#include "conversion.h"
#ifdef MPGLIB
#include "mp3.h"
#endif
#ifdef OGGVORBIS
#include "vorbis.h"
#endif
#include "../libresample/include/libresample.h"


#define NUM_TYPES 3
#define TYPE_UNKNOWN 0
#define TYPE_MP3 1
#define TYPE_VORBIS 2

extern struct decoder * initialize_decoder(int buflen);
extern int destroy_decoder(struct decoder * moh);
extern int read_data(struct decoder * moh, short sbuf[], int size);
extern int find_type(char * filename);

static int resample(void * handle, float * src, int srclen, float * dst, double factor, int last);
static int init_handler(void ** fh, int type, FILE *in, int *samplerate);
static int close_handler(void ** fh, int type);
#endif
