#include "common.h"
#include <stdio.h>

typedef struct id3tagstruct {
	char header[10];
	char *data;
	int size;
	char flags;
	int hasfooter;
	int curpos;
} id3tag;

id3tag ID3;

extern int getid3v2(char *buf, int buflen)
{
	if ((buflen + ID3.curpos) < 10) {
		memcpy(ID3.header+ID3.curpos, buf, buflen);
		ID3.curpos += buflen;
		return 0;
	}
	memcpy(ID3.header+ID3.curpos, buf, (10 - ID3.curpos));
	ID3.curpos += (10 - ID3.curpos);

	if(strncmp(ID3.header, "ID3", 3) == 0) {
		printf("In ID3\n");
		ID3.flags = ID3.header[5];
		ID3.size = ID3.header[9] + (ID3.header[8]<<7) + (ID3.header[7]<<14) + (ID3.header[6]<<21);
		ID3.hasfooter = (ID3.flags>>4)&0x1;
		printf("Size: %d Footer: %d\n", ID3.size, ID3.hasfooter);
		return (ID3.size + 10 + (10 * ID3.hasfooter));
	} else {
		return -1;
	}
}


int main()
{
	ID3.curpos = 0;
	char buf[8192];
	int len, ret;
	while ((len = read(0, &buf, 8192))>0 && ret==0) {
		ret = getid3v2(buf, len);
	}
	printf("Need to skip %d bytes\n", ret);
	return 0;
}
