#define MAX_MOHFILES 256
#include <stdio.h>

struct decoderbuffers {
	/* for use by music handlers */
	void *data;
	/* for use by resampler */
	void *resampler;
	/* Storage for resampled data */
	float *slin8khz;
	/* Storage for input data */
	float *input;
	/* Storage for output data */
	short *output;
	/* Amount of data currently in output buffer */
	int outputlen;
};

struct decoder {
       /* Directory containing files */
       char * dir;
       /* List of files available for playing */
       char *(files[MAX_MOHFILES]);
       /* Random mode */
       int random;
       /* Number of files available for playing */
       int numfiles;
       /* Index of file being played */
       int curfile;
       /* Type of file being played */
       int curtype;
       /* Ratio of 8000/samplerate of current file */
       double curfactor;
       /* FD for file being played */
       FILE *input;
       /* Are we playing a file now? */
       int infile;
       /* Size of buffers */
       int buflen;
       /* Storage area for internal buffers */
       struct decoderbuffers buffs;
};

extern struct decoder * initialize_decoder(int buflen);
extern int destroy_decoder(struct decoder * moh);
extern int read_data(struct decoder * moh, short sbuf[], int buflen);
extern int find_type(char *filename);
