#include <vorbis/vorbisfile.h>
#include <asterisk/logger.h>
#include <asterisk/options.h>
#include "vorbis.h"


extern int init_vorbis(void ** fh, FILE *in, int *samplerate)
{
	OggVorbis_File *vh;
	*fh = (OggVorbis_File *)malloc(sizeof(OggVorbis_File));
	vh = *fh;

	if(ov_open(in, *fh, NULL, 0) < 0) {
        	fprintf(stderr, "ERROR: Failed to open input as vorbis\n");
        	fclose(in);
        	return(0);
	}
	*samplerate = vh->vi->rate;
	return 1;
}

extern int read_vorbis(void *fh, float * buf, int buflen)
{
	int bs = 0;
	float ** localbuf;
	int ret = ov_read_float(fh, &localbuf, buflen, &bs);
	if (ret>0) memcpy(buf, *localbuf, ret*sizeof(float));
	return ret;
}

extern int close_vorbis(void **fh)
{
	ov_clear(*fh);
	free(*fh);
	return 1;
}
